(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms'), require('@angular/core'), require('rxjs/operators'), require('rxjs'), require('tippy.js')) :
    typeof define === 'function' && define.amd ? define('ng-easy-validation', ['exports', '@angular/forms', '@angular/core', 'rxjs/operators', 'rxjs', 'tippy.js'], factory) :
    (global = global || self, factory(global['ng-easy-validation'] = {}, global.ng.forms, global.ng.core, global.rxjs.operators, global.rxjs, global.tippy));
}(this, (function (exports, forms, core, operators, rxjs, tippy) { 'use strict';

    tippy = tippy && Object.prototype.hasOwnProperty.call(tippy, 'default') ? tippy['default'] : tippy;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var ValidatorConfig = /** @class */ (function () {
        function ValidatorConfig(identifier, validator, message, tooltipsOnInit, alwaysEvaluate) {
            if (message === void 0) { message = ""; }
            if (tooltipsOnInit === void 0) { tooltipsOnInit = false; }
            if (alwaysEvaluate === void 0) { alwaysEvaluate = false; }
            this.message = "";
            this.tooltipsOnInit = false;
            this.alwaysEvaluate = false;
            this.validator = validator;
            this.identifier = identifier;
            this.message = message,
                this.tooltipsOnInit = tooltipsOnInit;
            this.alwaysEvaluate = alwaysEvaluate;
        }
        return ValidatorConfig;
    }());


    (function (ValidatorId) {
        ValidatorId["Required"] = "required";
        ValidatorId["Pattern"] = "pattern";
        ValidatorId["RequiredTrue"] = "required";
        ValidatorId["NullValidator"] = "nullvalidator";
        ValidatorId["MinLength"] = "minlength";
        ValidatorId["MaxLength"] = "maxlength";
        ValidatorId["Email"] = "email";
        ValidatorId["Max"] = "max";
        ValidatorId["Min"] = "min";
        ValidatorId["Between"] = "between";
        ValidatorId["InvalidValues"] = "invalidValues";
        ValidatorId["RequiredValues"] = "requiredValues";
        ValidatorId["InvalidCharacters"] = "invalidCharacters";
        ValidatorId["SqlObjectName"] = "sqlObjectName";
        ValidatorId["IsInteger"] = "isInteger";
        ValidatorId["IsNumeric"] = "isNumeric";
        ValidatorId["isAlphaNumeric"] = "isAlphaNumeric";
        ValidatorId["isAlphabetical"] = "isAlphabetical";
        ValidatorId["startsWith"] = "startsWith";
        ValidatorId["endsWith"] = "endsWith";
    })(exports.ɵb || (exports.ɵb = {}));

    var NgEasyValidationService = /** @class */ (function () {
        function NgEasyValidationService() {
            this.validationResultSubject = new rxjs.Subject();
        }
        NgEasyValidationService.prototype.validate = function (requirements, formGroup) {
            var result = [];
            for (var field in formGroup.controls) {
                var control = formGroup.controls[field];
                if (!control.errors)
                    continue;
                var _loop_1 = function (errorIdentifier) {
                    var config = JSON.parse(JSON.stringify(requirements[field].find(function (x) { return x.identifier == errorIdentifier; })));
                    this_1.setErrorMessage(field, control, config);
                    result.push(new ValidationResult(field, config, !control.dirty && !config.tooltipsOnInit));
                };
                var this_1 = this;
                for (var errorIdentifier in control.errors) {
                    _loop_1(errorIdentifier);
                }
            }
            ;
            this.validationResultSubject.next(result);
            return result;
        };
        NgEasyValidationService.prototype.setErrorMessage = function (field, control, config) {
            if (!config.message)
                config.message = this.generateErrorMessage(field, config.identifier, control.errors[config.identifier]);
            config.message = config.message.replace("<value>", control.value);
        };
        NgEasyValidationService.prototype.generateErrorMessage = function (field, requirementType, requirementDetails) {
            if (requirementDetails === void 0) { requirementDetails = null; }
            var errorMessage = "";
            field = field[0].toUpperCase() + field.substr(1);
            switch (requirementType) {
                case exports.ɵb.Required:
                    errorMessage = field + " is required";
                    break;
                case exports.ɵb.Pattern:
                    errorMessage = field + " isn't in the right format. The format must be: " + requirementDetails.requiredPattern;
                    break;
                case exports.ɵb.Between:
                    errorMessage = field + " must be between " + requirementDetails.min + " and " + requirementDetails.max;
                    break;
                case exports.ɵb.Email:
                    errorMessage = field + " must be a valid e-mail address";
                    break;
                case exports.ɵb.Max:
                    errorMessage = field + " must be lower than or equal to " + requirementDetails.max;
                    break;
                case exports.ɵb.Min:
                    errorMessage = field + " must be higher than or equal to " + requirementDetails.min;
                    break;
                case exports.ɵb.RequiredTrue:
                    errorMessage = field + " must be selected";
                    break;
                case exports.ɵb.MinLength:
                    errorMessage = field + " has a minimum length of " + requirementDetails.requiredLength;
                    break;
                case exports.ɵb.MaxLength:
                    errorMessage = field + " has a maximum length of " + requirementDetails.requiredLength;
                    break;
                case exports.ɵb.RequiredValues:
                    var msg = this.humanizeList(requirementDetails.requiredValues);
                    errorMessage = field + " must be " + msg;
                    break;
                case exports.ɵb.InvalidValues:
                    var msg2 = this.humanizeList(requirementDetails.invalidValues);
                    errorMessage = field + " can't be " + msg2;
                    break;
                case exports.ɵb.InvalidCharacters:
                    var msg3 = this.humanizeList(requirementDetails.invalidCharacters);
                    errorMessage = field + " can't contain " + msg3;
                    break;
                case exports.ɵb.SqlObjectName:
                    errorMessage = field + " isn't a valid SQL name";
                    break;
                case exports.ɵb.IsInteger:
                    errorMessage = field + " must be an integer";
                    break;
                case exports.ɵb.IsNumeric:
                    errorMessage = field + " must be a numeric";
                    break;
                case exports.ɵb.isAlphaNumeric:
                    errorMessage = field + " must be alpha numerical";
                    break;
                case exports.ɵb.isAlphabetical:
                    errorMessage = field + " can only contain letters";
                    break;
                case exports.ɵb.startsWith:
                    errorMessage = field + " must start with '" + requirementDetails.startsWith + "'";
                    break;
                case exports.ɵb.endsWith:
                    errorMessage = field + " must end with '" + requirementDetails.endsWith + "'";
                    break;
                default:
                    errorMessage = field + " is invalid";
                    break;
            }
            return errorMessage;
        };
        NgEasyValidationService.prototype.humanizeList = function (values) {
            var msg = "";
            for (var i = 0; i < values.length; i++) {
                if (i == values.length - 1)
                    msg += " or ";
                msg += "'" + values[i] + "'";
                if (i < values.length - 2)
                    msg += ", ";
            }
            return msg;
        };
        NgEasyValidationService = __decorate([
            core.Injectable()
        ], NgEasyValidationService);
        return NgEasyValidationService;
    }());
    var ValidationResult = /** @class */ (function () {
        function ValidationResult(field, validatorConfig, isHidden) {
            this.field = field;
            this.validatorConfig = validatorConfig;
            this.isHidden = isHidden;
        }
        return ValidationResult;
    }());

    var NgEasyValidationDirective = /** @class */ (function () {
        function NgEasyValidationDirective(el, validationService, host) {
            this.validationService = validationService;
            this.host = host;
            this.requirements = {};
            this.tippyProps = {};
            this.validationDebounceTime = 0;
            this.invalidClass = "validation-error";
            this.validationEnabled = false;
            this.tippies = {};
            this.formId = Math.random().toString(36).substring(2);
            el.nativeElement.setAttribute('formId', this.formId);
        }
        Object.defineProperty(NgEasyValidationDirective.prototype, "ngEasyValidation", {
            set: function (requirements) {
                var e_1, _a;
                var newRequirements = {};
                for (var field in requirements) {
                    var configs = [];
                    try {
                        //Convert passed configurations to ValidatorConfig if they are not already
                        for (var _b = (e_1 = void 0, __values(requirements[field])), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var config = _c.value;
                            configs.push(new ValidatorConfig(config.validator.id, config.validator.validator, config.message, config.tooltipsOnInit || false, config.validator.alwaysEvaluate || false));
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    newRequirements[field] = configs;
                }
                this.requirements = newRequirements;
            },
            enumerable: true,
            configurable: true
        });
        NgEasyValidationDirective.prototype.ngOnInit = function () {
            this.initValidationSubscription();
            this.setDefaultTippyProps();
        };
        NgEasyValidationDirective.prototype.initValidationSubscription = function () {
            var _this = this;
            this.validationSubscription = this.host.form.valueChanges
                .pipe(operators.debounceTime(this.validationDebounceTime), operators.filter(function (_) { return _this.validationEnabled; }), operators.tap(this.validate.bind(this))).subscribe();
        };
        NgEasyValidationDirective.prototype.setDefaultTippyProps = function () {
            if (!this.tippyProps.allowHTML)
                this.tippyProps.allowHTML = true;
            tippy.setDefaultProps(this.tippyProps);
        };
        NgEasyValidationDirective.prototype.ngOnDestroy = function () {
            if (this.validationSubscription)
                this.validationSubscription.unsubscribe();
        };
        NgEasyValidationDirective.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (Object.keys(this.requirements).length == 0)
                this.validationEnabled = true;
            if (changes.ngEasyValidation) {
                setTimeout(function () {
                    _this.ngEasyValidation = changes.ngEasyValidation.currentValue;
                    _this.initFieldConfigurations();
                    _this.host.form.updateValueAndValidity();
                }, 200);
            }
        };
        NgEasyValidationDirective.prototype.initFieldConfigurations = function () {
            var e_2, _a;
            if (!this.requirements)
                return;
            this.validationEnabled = false;
            var inputFields = this.getUsableInputFields(this.getFormElement());
            try {
                for (var inputFields_1 = __values(inputFields), inputFields_1_1 = inputFields_1.next(); !inputFields_1_1.done; inputFields_1_1 = inputFields_1.next()) {
                    var element = inputFields_1_1.value;
                    var field = element.getAttribute("name");
                    var control = this.host.form.controls[field];
                    var reqs = this.requirements[field];
                    var isDirty = this.setFieldIsDirty(reqs, control);
                    this.setFieldValidators(reqs, control);
                    this.setFieldTippy(reqs, field, element, isDirty);
                    control.updateValueAndValidity();
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (inputFields_1_1 && !inputFields_1_1.done && (_a = inputFields_1.return)) _a.call(inputFields_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            this.validationEnabled = true;
        };
        NgEasyValidationDirective.prototype.setFieldIsDirty = function (requirements, control) {
            var hasValue = control.value && control.value.length > 0;
            var mustValidateOnInit = requirements && requirements.some(function (x) { return x.tooltipsOnInit; });
            if (hasValue || mustValidateOnInit)
                control.markAsDirty();
            return hasValue || mustValidateOnInit;
        };
        NgEasyValidationDirective.prototype.setFieldValidators = function (requirements, control) {
            var reqsToAdd = [];
            reqsToAdd.push.apply(reqsToAdd, __spread(requirements.map(function (x) { return x.validator; })));
            control.clearValidators();
            control.setValidators(reqsToAdd);
        };
        NgEasyValidationDirective.prototype.setFieldTippy = function (requirements, field, element, isDirty) {
            var instance = this.tippies[field];
            if (!instance) {
                instance = tippy(element);
                this.tippies[field] = instance;
                if (!isDirty && !requirements.some(function (x) { return x.tooltipsOnInit; }))
                    setTimeout(instance.disable, 10);
            }
        };
        NgEasyValidationDirective.prototype.validate = function () {
            var _this = this;
            var formEl = this.getFormElement();
            if (!formEl)
                return;
            var inputFields = this.getUsableInputFields(formEl);
            this.validationEnabled = false;
            this.reEvaluateFields(inputFields);
            setTimeout(function () { return _this.validationEnabled = true; }, this.validationDebounceTime);
            var validationResult = this.validationService.validate(this.requirements, this.host.form);
            this.updateFieldsLayout(inputFields, validationResult);
        };
        NgEasyValidationDirective.prototype.reEvaluateFields = function (inputFields) {
            var e_3, _a;
            var evaluateForm = false;
            try {
                for (var inputFields_2 = __values(inputFields), inputFields_2_1 = inputFields_2.next(); !inputFields_2_1.done; inputFields_2_1 = inputFields_2.next()) {
                    var element = inputFields_2_1.value;
                    var field = element.getAttribute("name");
                    var control = this.host.form.controls[field];
                    if (this.requirements[field].some(function (x) { return x.alwaysEvaluate; })) {
                        control.updateValueAndValidity();
                        evaluateForm = true;
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (inputFields_2_1 && !inputFields_2_1.done && (_a = inputFields_2.return)) _a.call(inputFields_2);
                }
                finally { if (e_3) throw e_3.error; }
            }
            if (evaluateForm)
                this.host.form.updateValueAndValidity();
        };
        NgEasyValidationDirective.prototype.updateFieldsLayout = function (inputFields, allErrors) {
            var e_4, _a;
            var _loop_1 = function (el) {
                var field = el.getAttribute("name");
                var errors = allErrors.filter(function (x) { return x.field == field; });
                var hasError = errors.length == 0 || errors.some(function (x) { return x.isHidden; });
                this_1.updateFieldTippy(el, hasError, field, errors);
                this_1.updateFieldLayout(el, hasError);
            };
            var this_1 = this;
            try {
                for (var inputFields_3 = __values(inputFields), inputFields_3_1 = inputFields_3.next(); !inputFields_3_1.done; inputFields_3_1 = inputFields_3.next()) {
                    var el = inputFields_3_1.value;
                    _loop_1(el);
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (inputFields_3_1 && !inputFields_3_1.done && (_a = inputFields_3.return)) _a.call(inputFields_3);
                }
                finally { if (e_4) throw e_4.error; }
            }
        };
        NgEasyValidationDirective.prototype.updateFieldTippy = function (el, hasError, field, errors) {
            var tippyInstance = this.tippies[field];
            if (hasError) {
                tippyInstance.disable();
            }
            else {
                var errorMessage = this.buildErrorMessage(errors);
                tippyInstance.setContent(errorMessage);
                tippyInstance.enable();
                if (this.isMouseOnElement(el))
                    tippyInstance.show();
            }
        };
        NgEasyValidationDirective.prototype.updateFieldLayout = function (el, hasError) {
            var hasClass = el.classList.contains(this.invalidClass);
            if (hasError && !hasClass) {
                el.classList.add(this.invalidClass);
            }
            else if (!hasError && hasClass) {
                el.classList.remove(this.invalidClass);
            }
        };
        NgEasyValidationDirective.prototype.isMouseOnElement = function (element) {
            var hoverEls = document.querySelectorAll("input:hover, textarea:hover, select:hover");
            var hoverEl = hoverEls[hoverEls.length - 1];
            return hoverEl == element && element == document.activeElement;
        };
        NgEasyValidationDirective.prototype.buildErrorMessage = function (validationResults) {
            var e_5, _a;
            var errorMessage = "";
            var errorMessages = validationResults.map(function (x) { return x.validatorConfig.message || "This field is incorrect"; }) || [];
            if (errorMessages.length > 1) {
                errorMessage += "<ul style='list-style-position:outside;padding-left:18px;margin:0'>";
                try {
                    for (var errorMessages_1 = __values(errorMessages), errorMessages_1_1 = errorMessages_1.next(); !errorMessages_1_1.done; errorMessages_1_1 = errorMessages_1.next()) {
                        var msg = errorMessages_1_1.value;
                        errorMessage += "<li>" + msg + "</li>";
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (errorMessages_1_1 && !errorMessages_1_1.done && (_a = errorMessages_1.return)) _a.call(errorMessages_1);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
                errorMessage += "</ul>";
            }
            if (errorMessages.length == 1) {
                errorMessage = errorMessages[0];
            }
            return errorMessage;
        };
        NgEasyValidationDirective.prototype.getFormElement = function () {
            return document.querySelectorAll('[formId="' + this.formId + '"]')[0];
        };
        NgEasyValidationDirective.prototype.getUsableInputFields = function (formElement) {
            var _this = this;
            var inputFields = formElement.querySelectorAll("input, textarea, select");
            var filteredInputFields = Array.from(inputFields).filter(function (x) { return Object.keys(_this.requirements).includes(x.getAttribute("name")); });
            return filteredInputFields;
        };
        NgEasyValidationDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: NgEasyValidationService },
            { type: forms.NgForm }
        ]; };
        __decorate([
            core.Input("ngEasyValidation"),
            __metadata("design:type", Object),
            __metadata("design:paramtypes", [Object])
        ], NgEasyValidationDirective.prototype, "ngEasyValidation", null);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], NgEasyValidationDirective.prototype, "tippyProps", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Number)
        ], NgEasyValidationDirective.prototype, "validationDebounceTime", void 0);
        NgEasyValidationDirective = __decorate([
            core.Directive({
                selector: '[ngEasyValidation]',
                providers: [NgEasyValidationService]
            }),
            __metadata("design:paramtypes", [core.ElementRef,
                NgEasyValidationService,
                forms.NgForm])
        ], NgEasyValidationDirective);
        return NgEasyValidationDirective;
    }());

    var ValidatorInfo = /** @class */ (function () {
        function ValidatorInfo(validator, id, alwaysEvaluate) {
            if (alwaysEvaluate === void 0) { alwaysEvaluate = false; }
            this.validator = validator;
            this.id = id;
            this.alwaysEvaluate = alwaysEvaluate;
        }
        return ValidatorInfo;
    }());

    //Wrapper methods around Angular's validators
    function required() {
        return new ValidatorInfo(forms.Validators.required, exports.ɵb.Required);
    }
    function pattern(regex) {
        return new ValidatorInfo(forms.Validators.pattern(regex), exports.ɵb.Pattern);
    }
    function requiredTrue() {
        return new ValidatorInfo(forms.Validators.requiredTrue, exports.ɵb.Required);
    }
    function nullValidator() {
        return new ValidatorInfo(forms.Validators.required, exports.ɵb.NullValidator);
    }
    function minLength(minLength) {
        return new ValidatorInfo(forms.Validators.minLength(minLength), exports.ɵb.MinLength);
    }
    function maxLength(maxLength) {
        return new ValidatorInfo(forms.Validators.maxLength(maxLength), exports.ɵb.MaxLength);
    }
    function email() {
        return new ValidatorInfo(forms.Validators.required, exports.ɵb.Email);
    }
    function min(min) {
        return new ValidatorInfo(forms.Validators.min(min), exports.ɵb.Min);
    }
    function max(max) {
        return new ValidatorInfo(forms.Validators.max(max), exports.ɵb.Max);
    }
    //Custom validators
    function between(min, max) {
        var res = function (control) {
            return control.value && (control.value > max || control.value < min) ? { 'between': { value: control.value, max: max, min: min } } : null;
        };
        return new ValidatorInfo(res, exports.ɵb.Between);
    }
    function invalidValues(invalidValues, valueModifier) {
        if (valueModifier === void 0) { valueModifier = function (x) { return x; }; }
        var res = function (control) {
            var controlValue = valueModifier(control.value);
            if (!(invalidValues instanceof Array))
                invalidValues = [invalidValues];
            return invalidValues.map(function (x) { return typeof x == "string" ? x.toLowerCase() : x; }).includes(typeof controlValue == "string" ? controlValue.toLowerCase() : controlValue) ? { 'invalidValues': { value: controlValue, invalidValues: invalidValues } } : null;
        };
        return new ValidatorInfo(res, exports.ɵb.InvalidValues);
    }
    function requiredValues(requiredValues, valueModifier) {
        if (valueModifier === void 0) { valueModifier = function (x) { return x; }; }
        var res = function (control) {
            var controlValue = valueModifier(control.value);
            if (!(requiredValues instanceof Array))
                requiredValues = [requiredValues];
            return !requiredValues.map(function (x) { return typeof x == "string" ? x.toLowerCase() : x; }).includes(typeof controlValue == "string" ? controlValue.toLowerCase() : controlValue) ? { 'requiredValues': { value: controlValue, requiredValues: requiredValues } } : null;
        };
        return new ValidatorInfo(res, exports.ɵb.RequiredValues);
    }
    function invalidCharacters(invalidCharacters) {
        var regex = "^[^";
        for (var i = 0; i < invalidCharacters.length; i++) {
            var c = invalidCharacters[i];
            if ("[\^$.|?*+()".includes(c))
                regex += "\\";
            regex += c;
        }
        regex += "]*$";
        var res = function (control) {
            return !(new RegExp(regex, "i")).test(control.value) ? { 'invalidCharacters': { value: control.value, invalidCharacters: invalidCharacters } } : null;
        };
        return new ValidatorInfo(res, exports.ɵb.InvalidCharacters);
    }
    function sqlObjectName() {
        var res = function (control) {
            return (control.value && !(new RegExp("^[_a-zA-Zß#][0-9a-zA-Zß_@$#]*$", "i")).test(control.value)) ? { 'sqlObjectName': { value: control.value } } : null;
        };
        return new ValidatorInfo(res, exports.ɵb.SqlObjectName);
    }
    function conditionalValidator(validator, condition) {
        var res = function (control) {
            if (!condition(control))
                return null;
            return validator.validator(control);
        };
        return new ValidatorInfo(res, validator.id, true);
    }
    function isInteger() {
        var res = function (control) {
            var value = control.value || "";
            return !(new RegExp("^[0-9]*$", "i")).test(value) ? { 'isInteger': { value: value } } : null;
        };
        return new ValidatorInfo(res, exports.ɵb.IsInteger);
    }
    function isNumeric() {
        var res = function (control) {
            var value = control.value || "";
            return !(new RegExp("^[0-9]*[.,]?[0-9]*$", "i")).test(value) ? { 'isNumeric': { value: value } } : null;
        };
        return new ValidatorInfo(res, exports.ɵb.IsNumeric);
    }
    function isAlphaNumeric() {
        var res = function (control) {
            var value = control.value || "";
            var code, i, len;
            for (i = 0, len = value.length; i < len; i++) {
                code = value.charCodeAt(i);
                if (!(code > 47 && code < 58) && // numeric (0-9)
                    !(code > 64 && code < 91) && // upper alpha (A-Z)
                    !(code > 96 && code < 123)) { // lower alpha (a-z)
                    return { 'isAlphaNumeric': { value: value } };
                }
            }
            return null;
        };
        return new ValidatorInfo(res, exports.ɵb.isAlphaNumeric);
    }
    function isAlphabetical() {
        var res = function (control) {
            var value = control.value || "";
            var code, i, len;
            for (i = 0, len = value.length; i < len; i++) {
                code = value.charCodeAt(i);
                if (!(code > 64 && code < 91) && // upper alpha (A-Z)
                    !(code > 96 && code < 123)) { // lower alpha (a-z)
                    return { 'isAlphabetical': { value: value } };
                }
            }
            return null;
        };
        return new ValidatorInfo(res, exports.ɵb.isAlphabetical);
    }
    function startsWith(str) {
        var res = function (control) {
            var value = control.value || "";
            return !value || value.startsWith(str) ? null : { "startsWith": { value: value, startsWith: str } };
        };
        return new ValidatorInfo(res, exports.ɵb.startsWith);
    }
    function endsWith(str) {
        var res = function (control) {
            var value = control.value || "";
            return !value || value.endsWith(str) ? null : { "endsWith": { value: value, endsWith: str } };
        };
        return new ValidatorInfo(res, exports.ɵb.endsWith);
    }

    var NgEasyValidationModule = /** @class */ (function () {
        function NgEasyValidationModule() {
        }
        NgEasyValidationModule = __decorate([
            core.NgModule({
                imports: [],
                declarations: [
                    NgEasyValidationDirective
                ],
                providers: [
                    NgEasyValidationService
                ],
                exports: [
                    NgEasyValidationDirective
                ]
            })
        ], NgEasyValidationModule);
        return NgEasyValidationModule;
    }());

    exports.NgEasyValidationDirective = NgEasyValidationDirective;
    exports.NgEasyValidationModule = NgEasyValidationModule;
    exports.ValidatorInfo = ValidatorInfo;
    exports.between = between;
    exports.conditionalValidator = conditionalValidator;
    exports.email = email;
    exports.endsWith = endsWith;
    exports.invalidCharacters = invalidCharacters;
    exports.invalidValues = invalidValues;
    exports.isAlphaNumeric = isAlphaNumeric;
    exports.isAlphabetical = isAlphabetical;
    exports.isInteger = isInteger;
    exports.isNumeric = isNumeric;
    exports.max = max;
    exports.maxLength = maxLength;
    exports.min = min;
    exports.minLength = minLength;
    exports.nullValidator = nullValidator;
    exports.pattern = pattern;
    exports.required = required;
    exports.requiredTrue = requiredTrue;
    exports.requiredValues = requiredValues;
    exports.sqlObjectName = sqlObjectName;
    exports.startsWith = startsWith;
    exports.ɵa = NgEasyValidationService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-easy-validation.umd.js.map
