import { ValidatorInfo } from './validator-id-map';
export declare function required(): ValidatorInfo;
export declare function pattern(regex: string): ValidatorInfo;
export declare function requiredTrue(): ValidatorInfo;
export declare function nullValidator(): ValidatorInfo;
export declare function minLength(minLength: number): ValidatorInfo;
export declare function maxLength(maxLength: number): ValidatorInfo;
export declare function email(): ValidatorInfo;
export declare function min(min: number): ValidatorInfo;
export declare function max(max: number): ValidatorInfo;
export declare function between(min: number, max: number): ValidatorInfo;
export declare function invalidValues(invalidValues: any[] | any, valueModifier?: (any: any) => any): ValidatorInfo;
export declare function requiredValues(requiredValues: any[] | any, valueModifier?: (any: any) => any): ValidatorInfo;
export declare function invalidCharacters(invalidCharacters: string): ValidatorInfo;
export declare function sqlObjectName(): ValidatorInfo;
export declare function conditionalValidator(validator: ValidatorInfo, condition: (AbstractControl: any) => boolean): ValidatorInfo;
export declare function isInteger(): ValidatorInfo;
export declare function isNumeric(): ValidatorInfo;
export declare function isAlphaNumeric(): ValidatorInfo;
export declare function isAlphabetical(): ValidatorInfo;
export declare function startsWith(str: string): ValidatorInfo;
export declare function endsWith(str: string): ValidatorInfo;
