import { Subject } from "rxjs";
import { ValidatorConfig } from "../interfaces/validator-config";
import { FormGroup } from "@angular/forms";
export declare class NgEasyValidationService {
    validationResultSubject: Subject<ValidationResult[]>;
    validate(requirements: {
        [key: string]: ValidatorConfig[];
    }, formGroup: FormGroup): ValidationResult[];
    private setErrorMessage;
    private generateErrorMessage;
    private humanizeList;
}
export declare class ValidationResult {
    field: string;
    validatorConfig: ValidatorConfig;
    isHidden: boolean;
    constructor(field: string, validatorConfig: ValidatorConfig, isHidden: boolean);
}
